"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/endpoint_module.py.jinja

The main changes are:
- Update the API call responses to either return the successful response type or raise an error by:
    - Updating the _parse_response function to raise an error if the response status code is not in the 2xx range
- Inject a client into every method via a context manager
"""

from http import HTTPStatus
from typing import Any, Dict

import httpx

from ...client import _client_context
from ...errors import get_error_for_response
from ...models.evaluation_request import EvaluationRequest
from ...models.evaluation_response import EvaluationResponse
from ...types import Response


def _get_kwargs(
    model_name_or_id: str,
    *,
    body: EvaluationRequest,
) -> dict[str, Any]:
    headers: Dict[str, Any] = {}

    _kwargs: dict[str, Any] = {
        "method": "post",
        "url": f"/classification_model/{model_name_or_id}/evaluation",
    }

    _body = body.to_dict()

    _kwargs["json"] = _body
    headers["Content-Type"] = "application/json"

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(*, response: httpx.Response) -> EvaluationResponse:
    if response.status_code == 201:
        response_201 = EvaluationResponse.from_dict(response.json())

        return response_201
    if response.status_code == 401:
        raise get_error_for_response(response)
    if response.status_code == 500:
        raise get_error_for_response(response)
    if response.status_code == 503:
        raise get_error_for_response(response)
    if response.status_code == 422:
        raise get_error_for_response(response)
    if response.status_code == 409:
        raise get_error_for_response(response)
    else:
        raise get_error_for_response(response)


def _build_response(*, response: httpx.Response) -> Response[EvaluationResponse]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(response=response),
    )


def sync_detailed(
    model_name_or_id: str,
    *,
    body: EvaluationRequest,
) -> Response[EvaluationResponse]:
    """Create Evaluation

    Args:
        model_name_or_id (str):
        body (EvaluationRequest):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[EvaluationResponse]
    """

    kwargs = _get_kwargs(
        model_name_or_id=model_name_or_id,
        body=body,
    )

    with _client_context() as client:
        response = client.get_httpx_client().request(
            **kwargs,
        )

        return _build_response(response=response)


def sync(
    model_name_or_id: str,
    *,
    body: EvaluationRequest,
) -> EvaluationResponse:
    """Create Evaluation

    Args:
        model_name_or_id (str):
        body (EvaluationRequest):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        EvaluationResponse
    """

    return sync_detailed(
        model_name_or_id=model_name_or_id,
        body=body,
    ).parsed


async def asyncio_detailed(
    model_name_or_id: str,
    *,
    body: EvaluationRequest,
) -> Response[EvaluationResponse]:
    """Create Evaluation

    Args:
        model_name_or_id (str):
        body (EvaluationRequest):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[EvaluationResponse]
    """

    kwargs = _get_kwargs(
        model_name_or_id=model_name_or_id,
        body=body,
    )

    with _client_context() as client:
        response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(response=response)


async def asyncio(
    model_name_or_id: str,
    *,
    body: EvaluationRequest,
) -> EvaluationResponse:
    """Create Evaluation

    Args:
        model_name_or_id (str):
        body (EvaluationRequest):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        EvaluationResponse
    """

    return (
        await asyncio_detailed(
            model_name_or_id=model_name_or_id,
            body=body,
        )
    ).parsed
