"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/endpoint_module.py.jinja

The main changes are:
- Update the API call responses to either return the successful response type or raise an error by:
    - Updating the _parse_response function to raise an error if the response status code is not in the 2xx range
- Inject a client into every method via a context manager
"""

from http import HTTPStatus
from typing import Any

import httpx

from ...client import _client_context
from ...errors import get_error_for_response
from ...models.embedding_evaluation_response import EmbeddingEvaluationResponse
from ...types import Response


def _get_kwargs(
    name_or_id: str,
    task_id: str,
) -> dict[str, Any]:
    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": f"/datasource/{name_or_id}/embedding_evaluation/{task_id}",
    }

    return _kwargs


def _parse_response(*, response: httpx.Response) -> EmbeddingEvaluationResponse:
    if response.status_code == 200:
        response_200 = EmbeddingEvaluationResponse.from_dict(response.json())

        return response_200
    if response.status_code == 401:
        raise get_error_for_response(response)
    if response.status_code == 500:
        raise get_error_for_response(response)
    if response.status_code == 503:
        raise get_error_for_response(response)
    if response.status_code == 422:
        raise get_error_for_response(response)
    if response.status_code == 404:
        raise get_error_for_response(response)
    else:
        raise get_error_for_response(response)


def _build_response(*, response: httpx.Response) -> Response[EmbeddingEvaluationResponse]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(response=response),
    )


def sync_detailed(
    name_or_id: str,
    task_id: str,
) -> Response[EmbeddingEvaluationResponse]:
    """Get Embedding Evaluation

    Args:
        name_or_id (str):
        task_id (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[EmbeddingEvaluationResponse]
    """

    kwargs = _get_kwargs(
        name_or_id=name_or_id,
        task_id=task_id,
    )

    with _client_context() as client:
        response = client.get_httpx_client().request(
            **kwargs,
        )

        return _build_response(response=response)


def sync(
    name_or_id: str,
    task_id: str,
) -> EmbeddingEvaluationResponse:
    """Get Embedding Evaluation

    Args:
        name_or_id (str):
        task_id (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        EmbeddingEvaluationResponse
    """

    return sync_detailed(
        name_or_id=name_or_id,
        task_id=task_id,
    ).parsed


async def asyncio_detailed(
    name_or_id: str,
    task_id: str,
) -> Response[EmbeddingEvaluationResponse]:
    """Get Embedding Evaluation

    Args:
        name_or_id (str):
        task_id (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[EmbeddingEvaluationResponse]
    """

    kwargs = _get_kwargs(
        name_or_id=name_or_id,
        task_id=task_id,
    )

    with _client_context() as client:
        response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(response=response)


async def asyncio(
    name_or_id: str,
    task_id: str,
) -> EmbeddingEvaluationResponse:
    """Get Embedding Evaluation

    Args:
        name_or_id (str):
        task_id (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        EmbeddingEvaluationResponse
    """

    return (
        await asyncio_detailed(
            name_or_id=name_or_id,
            task_id=task_id,
        )
    ).parsed
