"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/model.py.jinja

The main change is:
- Fix typing issues
"""

# flake8: noqa: C901

import datetime
from typing import TYPE_CHECKING, Any, Dict, List, Type, TypeVar, Union, cast

from attrs import define as _attrs_define
from attrs import field as _attrs_field
from dateutil.parser import isoparse

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.labeled_memory_lookup_metadata import LabeledMemoryLookupMetadata
    from ..models.memory_metrics import MemoryMetrics


T = TypeVar("T", bound="LabeledMemoryLookup")


@_attrs_define
class LabeledMemoryLookup:
    """Single labeled memory lookup result.

    Attributes:
        value (str):
        embedding (List[float]):
        source_id (Union[None, str]):
        metadata (LabeledMemoryLookupMetadata):
        memory_id (str):
        memory_version (int):
        created_at (datetime.datetime):
        updated_at (datetime.datetime):
        metrics (Union['MemoryMetrics', None]):
        label (int):
        label_name (Union[None, str]):
        lookup_score (float):
        reranker_score (Union[None, Unset, float]):
        reranker_embedding (Union[List[float], None, Unset]):
    """

    value: str
    embedding: List[float]
    source_id: Union[None, str]
    metadata: "LabeledMemoryLookupMetadata"
    memory_id: str
    memory_version: int
    created_at: datetime.datetime
    updated_at: datetime.datetime
    metrics: Union["MemoryMetrics", None]
    label: int
    label_name: Union[None, str]
    lookup_score: float
    reranker_score: Union[None, Unset, float] = UNSET
    reranker_embedding: Union[List[float], None, Unset] = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        from ..models.memory_metrics import MemoryMetrics

        value: str
        value = self.value

        embedding = self.embedding

        source_id: Union[None, str]
        source_id = self.source_id

        metadata = self.metadata.to_dict()

        memory_id = self.memory_id

        memory_version = self.memory_version

        created_at = self.created_at.isoformat()

        updated_at = self.updated_at.isoformat()

        metrics: Union[Dict[str, Any], None]
        if isinstance(self.metrics, MemoryMetrics):
            metrics = self.metrics.to_dict()
        else:
            metrics = self.metrics

        label = self.label

        label_name: Union[None, str]
        label_name = self.label_name

        lookup_score = self.lookup_score

        reranker_score: Union[None, Unset, float]
        if isinstance(self.reranker_score, Unset):
            reranker_score = UNSET
        else:
            reranker_score = self.reranker_score

        reranker_embedding: Union[List[float], None, Unset]
        if isinstance(self.reranker_embedding, Unset):
            reranker_embedding = UNSET
        elif isinstance(self.reranker_embedding, list):
            reranker_embedding = self.reranker_embedding

        else:
            reranker_embedding = self.reranker_embedding

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "value": value,
                "embedding": embedding,
                "source_id": source_id,
                "metadata": metadata,
                "memory_id": memory_id,
                "memory_version": memory_version,
                "created_at": created_at,
                "updated_at": updated_at,
                "metrics": metrics,
                "label": label,
                "label_name": label_name,
                "lookup_score": lookup_score,
            }
        )
        if reranker_score is not UNSET:
            field_dict["reranker_score"] = reranker_score
        if reranker_embedding is not UNSET:
            field_dict["reranker_embedding"] = reranker_embedding

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: dict[str, Any]) -> T:
        from ..models.labeled_memory_lookup_metadata import LabeledMemoryLookupMetadata
        from ..models.memory_metrics import MemoryMetrics

        d = src_dict.copy()

        def _parse_value(data: object) -> str:
            return cast(str, data)

        value = _parse_value(d.pop("value"))

        embedding = cast(List[float], d.pop("embedding"))

        def _parse_source_id(data: object) -> Union[None, str]:
            if data is None:
                return data
            return cast(Union[None, str], data)

        source_id = _parse_source_id(d.pop("source_id"))

        metadata = LabeledMemoryLookupMetadata.from_dict(d.pop("metadata"))

        memory_id = d.pop("memory_id")

        memory_version = d.pop("memory_version")

        created_at = isoparse(d.pop("created_at"))

        updated_at = isoparse(d.pop("updated_at"))

        def _parse_metrics(data: object) -> Union["MemoryMetrics", None]:
            if data is None:
                return data
            try:
                if not isinstance(data, dict):
                    raise TypeError()
                metrics_type_0 = MemoryMetrics.from_dict(data)

                return metrics_type_0
            except:  # noqa: E722
                pass
            return cast(Union["MemoryMetrics", None], data)

        metrics = _parse_metrics(d.pop("metrics"))

        label = d.pop("label")

        def _parse_label_name(data: object) -> Union[None, str]:
            if data is None:
                return data
            return cast(Union[None, str], data)

        label_name = _parse_label_name(d.pop("label_name"))

        lookup_score = d.pop("lookup_score")

        def _parse_reranker_score(data: object) -> Union[None, Unset, float]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, float], data)

        reranker_score = _parse_reranker_score(d.pop("reranker_score", UNSET))

        def _parse_reranker_embedding(data: object) -> Union[List[float], None, Unset]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            try:
                if not isinstance(data, list):
                    raise TypeError()
                reranker_embedding_type_0 = cast(List[float], data)

                return reranker_embedding_type_0
            except:  # noqa: E722
                pass
            return cast(Union[List[float], None, Unset], data)

        reranker_embedding = _parse_reranker_embedding(d.pop("reranker_embedding", UNSET))

        labeled_memory_lookup = cls(
            value=value,
            embedding=embedding,
            source_id=source_id,
            metadata=metadata,
            memory_id=memory_id,
            memory_version=memory_version,
            created_at=created_at,
            updated_at=updated_at,
            metrics=metrics,
            label=label,
            label_name=label_name,
            lookup_score=lookup_score,
            reranker_score=reranker_score,
            reranker_embedding=reranker_embedding,
        )

        labeled_memory_lookup.additional_properties = d
        return labeled_memory_lookup

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
