"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/model.py.jinja

The main change is:
- Fix typing issues
"""

# flake8: noqa: C901

from enum import Enum
from typing import Any, Type, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..models.memoryset_analysis_request_type import MemorysetAnalysisRequestType
from ..types import UNSET, Unset

T = TypeVar("T", bound="MemorysetAnalysisRequest")


@_attrs_define
class MemorysetAnalysisRequest:
    """
    Attributes:
        type (MemorysetAnalysisRequestType):
        neighbor_count (Union[Unset, int]):  Default: 10.
    """

    type: MemorysetAnalysisRequestType
    neighbor_count: Union[Unset, int] = 10
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        type = self.type.value if isinstance(self.type, Enum) else self.type

        neighbor_count = self.neighbor_count

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "type": type,
            }
        )
        if neighbor_count is not UNSET:
            field_dict["neighbor_count"] = neighbor_count

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: dict[str, Any]) -> T:
        d = src_dict.copy()
        type = MemorysetAnalysisRequestType(d.pop("type"))

        neighbor_count = d.pop("neighbor_count", UNSET)

        memoryset_analysis_request = cls(
            type=type,
            neighbor_count=neighbor_count,
        )

        memoryset_analysis_request.additional_properties = d
        return memoryset_analysis_request

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
