"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/model.py.jinja

The main change is:
- Fix typing issues
"""

# flake8: noqa: C901

import datetime
from enum import Enum
from typing import TYPE_CHECKING, Any, Dict, Type, TypeVar, Union, cast

from attrs import define as _attrs_define
from attrs import field as _attrs_field
from dateutil.parser import isoparse

from ..models.memoryset_analysis_response_type import MemorysetAnalysisResponseType
from ..models.task_status import TaskStatus

if TYPE_CHECKING:
    from ..models.analyze_neighbor_labels_result import AnalyzeNeighborLabelsResult
    from ..models.find_duplicates_analysis_result import FindDuplicatesAnalysisResult
    from ..models.memoryset_analysis_response_config import MemorysetAnalysisResponseConfig


T = TypeVar("T", bound="MemorysetAnalysisResponse")


@_attrs_define
class MemorysetAnalysisResponse:
    """
    Attributes:
        task_id (str):
        org_id (str):
        memoryset_id (str):
        type (MemorysetAnalysisResponseType):
        status (TaskStatus): Status of task in the task queue
        config (MemorysetAnalysisResponseConfig):
        result (Union['AnalyzeNeighborLabelsResult', 'FindDuplicatesAnalysisResult', None]):
        created_at (datetime.datetime):
        updated_at (datetime.datetime):
    """

    task_id: str
    org_id: str
    memoryset_id: str
    type: MemorysetAnalysisResponseType
    status: TaskStatus
    config: "MemorysetAnalysisResponseConfig"
    result: Union["AnalyzeNeighborLabelsResult", "FindDuplicatesAnalysisResult", None]
    created_at: datetime.datetime
    updated_at: datetime.datetime
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        from ..models.analyze_neighbor_labels_result import AnalyzeNeighborLabelsResult
        from ..models.find_duplicates_analysis_result import FindDuplicatesAnalysisResult

        task_id = self.task_id

        org_id = self.org_id

        memoryset_id = self.memoryset_id

        type = self.type.value if isinstance(self.type, Enum) else self.type

        status = self.status.value if isinstance(self.status, Enum) else self.status

        config = self.config.to_dict()

        result: Union[Dict[str, Any], None]
        if isinstance(self.result, AnalyzeNeighborLabelsResult):
            result = self.result.to_dict()
        elif isinstance(self.result, FindDuplicatesAnalysisResult):
            result = self.result.to_dict()
        else:
            result = self.result

        created_at = self.created_at.isoformat()

        updated_at = self.updated_at.isoformat()

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "task_id": task_id,
                "org_id": org_id,
                "memoryset_id": memoryset_id,
                "type": type,
                "status": status,
                "config": config,
                "result": result,
                "created_at": created_at,
                "updated_at": updated_at,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: dict[str, Any]) -> T:
        from ..models.analyze_neighbor_labels_result import AnalyzeNeighborLabelsResult
        from ..models.find_duplicates_analysis_result import FindDuplicatesAnalysisResult
        from ..models.memoryset_analysis_response_config import MemorysetAnalysisResponseConfig

        d = src_dict.copy()
        task_id = d.pop("task_id")

        org_id = d.pop("org_id")

        memoryset_id = d.pop("memoryset_id")

        type = MemorysetAnalysisResponseType(d.pop("type"))

        status = TaskStatus(d.pop("status"))

        config = MemorysetAnalysisResponseConfig.from_dict(d.pop("config"))

        def _parse_result(data: object) -> Union["AnalyzeNeighborLabelsResult", "FindDuplicatesAnalysisResult", None]:
            if data is None:
                return data
            try:
                if not isinstance(data, dict):
                    raise TypeError()
                result_type_0 = AnalyzeNeighborLabelsResult.from_dict(data)

                return result_type_0
            except:  # noqa: E722
                pass
            try:
                if not isinstance(data, dict):
                    raise TypeError()
                result_type_1 = FindDuplicatesAnalysisResult.from_dict(data)

                return result_type_1
            except:  # noqa: E722
                pass
            return cast(Union["AnalyzeNeighborLabelsResult", "FindDuplicatesAnalysisResult", None], data)

        result = _parse_result(d.pop("result"))

        created_at = isoparse(d.pop("created_at"))

        updated_at = isoparse(d.pop("updated_at"))

        memoryset_analysis_response = cls(
            task_id=task_id,
            org_id=org_id,
            memoryset_id=memoryset_id,
            type=type,
            status=status,
            config=config,
            result=result,
            created_at=created_at,
            updated_at=updated_at,
        )

        memoryset_analysis_response.additional_properties = d
        return memoryset_analysis_response

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
